<?php

declare(strict_types=1);

/*
 * Chill is a software for social workers
 *
 * For the full copyright and license information, please view
 * the LICENSE file that was distributed with this source code.
 */

namespace Chill\ActivityBundle\Tests\Export\Filter;

use Chill\ActivityBundle\Entity\Activity;
use Chill\ActivityBundle\Export\Filter\ByCreatorFilter;
use Chill\MainBundle\Entity\User;
use Chill\MainBundle\Test\Export\AbstractFilterTest;
use Doctrine\ORM\EntityManagerInterface;

/**
 * @internal
 *
 * @coversNothing
 */
final class ByCreatorFilterTest extends AbstractFilterTest
{
    private ByCreatorFilter $filter;

    protected function setUp(): void
    {
        self::bootKernel();

        $this->filter = self::getContainer()->get(ByCreatorFilter::class);
    }

    public function getFilter(): \Chill\ActivityBundle\Export\Filter\ByCreatorFilter
    {
        return $this->filter;
    }

    public static function getFormData(): array
    {
        $em = self::getContainer()->get(EntityManagerInterface::class);
        $array = $em->createQueryBuilder()
            ->from(User::class, 'u')
            ->select('u')
            ->getQuery()
            ->getResult();
        $data = [];
        foreach ($array as $a) {
            $data[] = [
                'accepted_users' => $a,
            ];
        }

        return $data;
    }

    public static function getQueryBuilders(): iterable
    {
        if (null === self::$kernel) {
            self::bootKernel();
        }
        $em = self::getContainer()->get(EntityManagerInterface::class);

        return [
            $em->createQueryBuilder()
                ->select('count(activity.id)')
                ->from(Activity::class, 'activity')
                ->join('activity.users', 'actusers'),
        ];
    }
}
